/* $Id: DebugData.java,v 1.7 2015/03/01 00:09:09 mit Exp $
/* v0.1.1 */

public class DebugData {
    private int Key;
    private int Length;
    private double CentStart;
    private double CentEnd; // len
    private double BeatMin;
    private double BeatMax;
    private double[] Beat;

    public DebugData() {}
    public DebugData(int k, int l, double cs, double ce,
		     double bi, double bx, double[] dt) {
	setDD(k, l, cs, ce, bi, bx, dt);
    }
    public DebugData(int k, double cs, double ce, MinMax mm) {
	setDD(k, cs, ce, mm);
    }
    public void setDD(int k, int l, double cs, double ce,
		      double bi, double bx, double[] dt) {
	Key = k;
	Length = l;
	CentStart = cs;
	CentEnd = ce;
	BeatMin = bi;
	BeatMax = bx;
	Beat = dt;
    }
    public void setDD(int k, double cs, double ce, MinMax mm) {
	Key = k;
	Length = mm.getLength();
	CentStart = cs;
	CentEnd = ce;
	BeatMin = mm.getMin();
	BeatMax = mm.getMax();
	Beat = mm.getBeat();
    }
    //
    public int getKey() {
	return Key;
    }
    public double getCentStart() {
	return CentStart;
    }
    public double getCentEnd() {
	return CentEnd;
    }
    public double getBeatMin() {
	return BeatMin;
    }
    public double getBeatMax() {
	return BeatMax;
    }
    public double[] getData() {
	return Beat;
    }
    public double getData(int num) {
	return Beat[num];
    }
    public int getLength() {
	return Length;
    }
    //
    public String toString() {
	StringBuilder str = new StringBuilder();
	str.append("Key#: ").append(Key);
	str.append(" Length: ").append(Length);
	str.append(" CentStart: ").append(CentStart);
	str.append(" CentEnd: ").append(CentEnd);
	str.append(" BeatMin: ").append(BeatMin);
	str.append(" BeatMax: ").append(BeatMax);

	return str.toString();
    }
}