/* $Id: jts.java,v 1.100 2017/02/02 08:30:40 mit3 Exp $
/* jts.java v0.6.3 */

import java.awt.*;
import java.awt.event.*;
import java.awt.List;
import java.applet.*;
import java.util.*;
import java.text.DecimalFormat;

public class jts extends Applet 
    implements ItemListener, ActionListener, AdjustmentListener,
	       MouseListener, MouseMotionListener
{
    final int KEY_BOARD = 88;
    final int OCTAVE = 12;
    final int P4TH = 5;
    final int P5TH = 7;
    final int PARTIAL = 20; // maxColor
    final int INHA = 0; // GRPH
    final int CENT = 1;
    final int BEAT = 2;
    final int PART = 3;
    final int ALLL = 4;
    final int WAVE_ = 5;
    final int FFT_ = 6;
    final int ENVE_ = 7;
    final int DEBG = 8;
    final int NONZ = 0; // tune_type
    final int OCT1 = 1; 
    final int OCT2 = 2;
    final int CURV = 3;
    final int ENVE = 4;
    final int TRIA = 5;
    final int CLEA = 6;
    final int SPLGF = 11025; //44100,22050,11025,8000
    final double TIME = 2.0;
    final double P2 = 2*Math.PI;
    final Color MC = Color.white;
    final Color KC = Color.green;
    final Color WC = Color.pink;
    final String[] TUNE =
    {"NonZero", "Octave", "2octave", "Curve", "Envelope", "Triads", "Clear"};
    final String[] BASS = {"Curve", "Straight", "Logarithm"};
    final String[] OCT_TYPE = {"2:1", "4:2", "6:3"};
    final String[] Graph =
    {"Inha.", "Cent", "Beat", "part.", "all", "Wave", "FFT", "Enve."};
    final String[] OCTAVE_NAME = {"A2","A1","A","a","a1","a2","a3","a4"};
    final String[] KEY_NAME =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    final String[] Smpl = {"15","14","13","12","11","10","9"};
    private static final long serialVersionUID = 1L;

    private Button[] btGraph;
    private Button btPlus;
    private Button btMinus;
    private Button btText;
    private Button btRev;
    private Button btAbso;
    private Button btAutoB;
    private Button btAutoCent;
    private Button btWide;
    private Button btNarrow;
    private Button btBend;
    private Button btDD;        // for debug
    private Scrollbar scrBass;
    private Scrollbar scrTreble;
    private Scrollbar scrA49i;
    private Scrollbar scrWound;
    private Scrollbar scrBeat4th;
    private Scrollbar scrBeat5th;
    private Scrollbar scrBeatOct;
    private Scrollbar scrDamp;
    private Scrollbar scrBend;
    private Scrollbar scrBendKey;
    private Label lbBass;
    private Label lbTreble;
    private Label lbA49i;
    private Label lbWound;
    private Label lbBeat4th;
    private Label lbBeat5th;
    private Label lbBeatOct;
    private Label lbDamp;
    private Label lbBend;
    private Label lbBendKey;
    private List lstInterval;
    private Choice chInterval;
    private Choice chPartial;
    private Choice chBass;
    private Choice chTune;
    private Choice chOctave;
    private Choice chSmpl;
    private TextArea taA;
    private TextField tfData;
    private CardLayout Card;
    private Panel deck;
    private Canvas can;
    private Panel PN, PE, PW, PS;

    private Graphics gi;
    private Image ig;
    private Font Fnt;
    private FontMetrics fm;
    private DecimalFormat df1;

    private boolean MOUSE_SW;
    private boolean GT;
    private boolean REV;
    private boolean ABS;
    private boolean BEAT_TXT;
    private boolean AUTO_BEAT;
    private boolean AUTO_CENT;
    private boolean GRPHsw;
    private boolean WAVE_SW;
    private boolean FFT_SW;
    private boolean ENVE_SW;
    private boolean BEND_SW;
    private boolean DEBUG = false;//false|true;
    private int W, H, H2;
    private int FONT;
    private int GRPH;
    private int GTMP;
    private int DOT, DSF;
    private int MOUSEX;
    private int KEY = 37-1;
    private int BKEY = 49-1;
    private int CENT_MAX = 40;
    private int BEAT_MAX = 10;
    private int BEAT_COUNT;
    private int WOUND;
    private int WAVE_LEN;
    private int N0; // 13;
    private int N;
    private int XBY = 2; // fft
    private int BASE;
    private double BYH; // inha.
    private double DKEY;
    private double BEAT_TEMP;
    private double WBY = 10.0; // wave
    private double FBY = 0.05; // fft
    private double EBY = 25.0; // envelope
    private double TD;
    private double DAMP = 1.0;
    private double[] Wave;
    private double[] Re;    // for fft
    private double[] Im;    // "
    private double[] Dat;   // "
    private double[] Gauss; // "
    private double[] Enve;
    private double[] FF;
    private Color[] GC;

    private Interval I;
    private MakeInharmonicity MI;
    private TuningCenter TC;
    private TuneAssort[] TA;
    private FFT F;

    public void init() {
	String fnt = getParameter("font");
        FONT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FONT);
        setFont(Fnt);
	fm = getFontMetrics(Fnt);
	df1 = new DecimalFormat("#0.0##");

	I = new Interval();
	TA = new TuneAssort[TUNE.length];

	buildLayout();
	initSeting();
	initColor();
	set_enabled();
	set_tune();
    }
    public void buildLayout() {
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

        deck = new Panel();
        Card = new CardLayout();
        deck.setLayout(Card);

	int num = Graph.length;
        PW = new Panel();
        PW.setLayout(new GridLayout(num+1,1,0,0));
	add(PW, "West");

	btGraph = new Button[num];
        for (int i = 0; i < num; i++) {
            btGraph[i] = new Button(Graph[i]);
            btGraph[i].addActionListener(this);
            PW.add(btGraph[i]);
        }

        btText = new Button("Graph");
        btText.addActionListener(this);
        PW.add(btText);
	//---

        PE = new Panel();
        PE.setLayout(new GridLayout(8,1,0,0));
	add(PE, "East");

        btPlus = new Button("+");
        btPlus.addActionListener(this);
        PE.add(btPlus);

        btMinus = new Button("-");
        btMinus.addActionListener(this);
        PE.add(btMinus);

	btWide = new Button("<>");
	btWide.addActionListener(this);
	PE.add(btWide);

	btNarrow = new Button("><");
	btNarrow.addActionListener(this);
	PE.add(btNarrow);

        btAbso = new Button("abs");
        btAbso.addActionListener(this);
        PE.add(btAbso);

        btRev = new Button("->");
        btRev.addActionListener(this);
        PE.add(btRev);

	btAutoCent = new Button("a.c.");
        btAutoCent.addActionListener(this);
        PE.add(btAutoCent);

	btBend = new Button("Bend");
	btBend.addActionListener(this);
	PE.add(btBend);
	//---

        PN = new Panel();
	PN.setLayout(new GridLayout(2,1,0,0));
	add(PN, "North");

        Panel n1 = new Panel();
        n1.setLayout(new FlowLayout());
        PN.add(n1);

        Panel n2 = new Panel();
        n2.setLayout(new FlowLayout());
        PN.add(n2);

	tfData = new TextField(26);
        tfData.setEditable(false);
        n1.add(tfData);

	int n = I.getInum();
	lstInterval = new List(1, true);
	for (int i = 0; i < n; i++) {
	    lstInterval.add(I.toString(i));
	}
	lstInterval.select(5);  // 4th
	lstInterval.select(7);  // 5th
	lstInterval.select(12); // octave
	lstInterval.select(17); // 2octave
	lstInterval.addItemListener(this);
	n1.add(lstInterval);

	chSmpl = new Choice();
	for (int i = 0; i < Smpl.length; i++)
	    chSmpl.addItem(Smpl[i]);
	n1.add(chSmpl);
	chSmpl.select(2);
	N0 = 13;
	chSmpl.addItemListener(this);

	if (DEBUG) {
	    btDD = new Button("D.D.");
	    btDD.addActionListener(this);
	    n1.add(btDD);
	}
	//

        chBass = new Choice();
        for (int i = 0; i < BASS.length; i++)
            chBass.addItem(BASS[i]);
        n2.add(chBass);
        chBass.addItemListener(this);

	chTune = new Choice();
        for (int i = 0; i < TUNE.length; i++) {
            chTune.addItem(TUNE[i]);
	}
        n2.add(chTune);
	chTune.select(0); // clear|nonZero
        chTune.addItemListener(this);

	chOctave = new Choice();
	for (int i = 0; i < OCT_TYPE.length; i++)
	    chOctave.addItem(OCT_TYPE[i]);
	n2.add(chOctave);
	chOctave.addItemListener(this);

        btAutoB = new Button("AutoBeat ");
        btAutoB.addActionListener(this);
        n2.add(btAutoB);

	chInterval = new Choice();
        for (int i = 0; i < I.getInum(); i++)
            chInterval.addItem(I.toString(i));
        n2.add(chInterval);
	chInterval.select(I.getIinte(OCTAVE));
        chInterval.addItemListener(this);

	chPartial = new Choice();
        for (int i = 0; i < PARTIAL; i++)
	  chPartial.addItem(""+(i+1));
        n2.add(chPartial);
	chPartial.select(7); // 8
        chPartial.addItemListener(this);
	//---

        PS = new Panel();
        PS.setLayout(new GridLayout(5,4,0,0));
	add(PS, "South");

	scrTreble = new Scrollbar(Scrollbar.HORIZONTAL,87,10,0,130);
        PS.add(scrTreble);
        scrTreble.setBlockIncrement(10);
        scrTreble.addAdjustmentListener(this);

        lbTreble = new Label("TrebleG:____", Label.LEFT);
        PS.add(lbTreble);

	lbBeat4th = new Label("Beat(P4th):___", Label.RIGHT);
	PS.add(lbBeat4th);

	scrBeat4th = new Scrollbar(Scrollbar.HORIZONTAL,413,1,0,601);
	PS.add(scrBeat4th);                               // -3.0~3.0
	scrBeat4th.setBlockIncrement(10);
	scrBeat4th.addAdjustmentListener(this);

        scrBass = new Scrollbar(Scrollbar.HORIZONTAL,60,10,0,130);
        PS.add(scrBass);
        scrBass.setBlockIncrement(10);
        scrBass.addAdjustmentListener(this);

        lbBass = new Label("BassG:____", Label.LEFT);
        PS.add(lbBass);

	lbBeat5th = new Label("Beat(P5th):___", Label.RIGHT);
	PS.add(lbBeat5th);

	scrBeat5th = new Scrollbar(Scrollbar.HORIZONTAL,336,1,0,601);
	PS.add(scrBeat5th);                               // -3.0~3.0
	scrBeat5th.setBlockIncrement(10);
	scrBeat5th.addAdjustmentListener(this);

        scrA49i = new Scrollbar(Scrollbar.HORIZONTAL,55,10,1,100);
        PS.add(scrA49i);                               // 0.01~1.0
        scrA49i.setBlockIncrement(10);
        scrA49i.addAdjustmentListener(this);

        lbA49i = new Label("A49I:____", Label.LEFT);
        PS.add(lbA49i);

	lbBeatOct = new Label("Beat(Octave):___", Label.RIGHT);
	PS.add(lbBeatOct);

	scrBeatOct = new Scrollbar(Scrollbar.HORIZONTAL,20,1,0,41);
	PS.add(scrBeatOct);                             // -1.0~3.0
	scrBeatOct.setBlockIncrement(10);
	scrBeatOct.addAdjustmentListener(this);

	scrWound = new Scrollbar(Scrollbar.HORIZONTAL,28,1,0,49);
	PS.add(scrWound);                            // 28-1,49-1
	scrWound.setBlockIncrement(10);
	scrWound.addAdjustmentListener(this);

	lbWound = new Label("WoundW:___", Label.LEFT);
	PS.add(lbWound);

	lbDamp = new Label("Damping:1.0 ", Label.RIGHT);
	PS.add(lbDamp);

	scrDamp = new Scrollbar(Scrollbar.HORIZONTAL,50,1,0,100);
	PS.add(scrDamp);                            // 0.01~1.99
	scrDamp.addAdjustmentListener(this);
	//
	scrBendKey = new Scrollbar(Scrollbar.HORIZONTAL,70,1,50,88);
	PS.add(scrBendKey);                            // 0.01~1.99
	scrBendKey.addAdjustmentListener(this);

	lbBendKey = new Label("BendKey: ", Label.LEFT);
	PS.add(lbBendKey);

	lbBend = new Label("Bend:___", Label.RIGHT);
	PS.add(lbBend);

	scrBend = new Scrollbar(Scrollbar.HORIZONTAL,87,10,0,130);
	PS.add(scrBend);                            // 0~0.13
	scrBend.setBlockIncrement(10);
	scrBend.addAdjustmentListener(this);
	//---

        can = new myCanvas();

        can.addMouseListener(this);
        can.addMouseMotionListener(this);

        Panel card1 = new Panel();
        card1.add(can);
        deck.add(card1, "card1");

        taA = new TextArea("", 16, 40, TextArea.SCROLLBARS_BOTH);
        taA.setFont(Fnt);
        taA.setEditable(false);

        ScrollPane card2 = new ScrollPane();
        card2.add(taA);
        deck.add(card2, "card2");

        add(deck, "Center");
    }
    public void initSeting() {
	MI = new MakeInharmonicity();
	TC = new TuningCenter(DEBUG);
	TC.setInha(MI.getInha());

	init_samplingf();
	set_nn();
	set_bass_grade(false);
	set_treble_grade(false);
	set_a49_inha(false);
	set_wound_wire(false);
	set_beat_4th(false);
	set_beat_5th(false);
	set_beat_octave(false);
	set_bend(false);
	set_bend_key(false);
    }
    public void set_nn() {
        N = (int)Math.pow(2, N0);
        F = new FFT(N);
 
        Re = new double[N];
        Im = new double[N];
        Dat = new double[N/2];

	init_gauss();
	init_envelope();
    }
    public void initColor() {
	GC = new Color[PARTIAL];
	double dc = 1.0/PARTIAL;
	float c0;
	for (int i = 0; i < PARTIAL; i++) {
	    c0 = (float)(dc*i);
	    GC[i] = Color.getHSBColor(c0, 1.0f, 1.0f);
	}
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = H/2;
	BASE = H-FONT*3;
	BYH = H/10.0;
	DKEY = (double)W/KEY_BOARD;
	setDot();

        can.setSize(W, H);
        ig = createImage(W, H);
        gi = ig.getGraphics();
        gi.setFont(Fnt);
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension de = PE.getSize();
        Dimension ds = PS.getSize();
        Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height)-5;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void set_enabled() {
	boolean fsw = (GRPH == FFT_);
	btWide.setEnabled(fsw);
	btNarrow.setEnabled(fsw);
 
	boolean isw = (GRPH != INHA);
	btPlus.setEnabled(isw);
	btMinus.setEnabled(isw);

	boolean absw = (TC.getTune() == 1 || TC.getTune() == 2);
	btAutoB.setEnabled(absw); // oct,2oct

	boolean ocsw = (TC.getTune() == 1); // oct
	chOctave.setEnabled(ocsw);

	boolean trsw = !(TC.getTune() == 5); // triads
	boolean cusw = !(TC.getTune() == 3); // curve
	boolean ensw = !(TC.getTune() == 4); // envelope
	lbBeatOct.setEnabled(ensw && trsw);

	boolean ausw = !(absw && AUTO_BEAT);
	scrBeatOct.setEnabled(ausw && ensw && trsw);

	scrBend.setEnabled(BEND_SW);
	lbBend.setEnabled(BEND_SW);
	scrBendKey.setEnabled(BEND_SW);
	lbBendKey.setEnabled(BEND_SW);

	if (DEBUG)
	    btDD.setEnabled(cusw);
    }
    //
    public void disp_sw() {
        if (GT)
            re_write();
        else
            can.repaint();
    }
    public void mouseMoved(MouseEvent me) {
	if (MOUSE_SW) {
            MOUSEX = me.getX();
	    KEY = (int)(MOUSEX/DKEY);
	    mouse_check();

	    disp_sw();
	}
    }
    public void mouse_check() {
	int itv = get_interval_inte();
	int min = REV ? itv : 0;
	int max = REV ? KEY_BOARD : KEY_BOARD-itv;
        if (KEY < min)
            KEY = min;
	if (KEY >= max)
	    KEY = max-1;

	set_bkey(itv);
    }
    public void set_bkey(int itv) {
	BKEY = REV ? KEY-itv : KEY+itv;

	if (BKEY < 0)
	    BKEY = 0;
	if (BKEY >= KEY_BOARD)
	    BKEY = KEY_BOARD-1;

	sw_off();
    }
    public void mouseDragged(MouseEvent me) {}
    public void mousePressed(MouseEvent m) {
	MOUSE_SW = !MOUSE_SW;

	disp_sw();
    }
    public void mouseClicked(MouseEvent m) {}
    public void mouseReleased(MouseEvent m){}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrBass)
	    set_bass_grade(true);
	if (e.getSource() == scrTreble)
	    set_treble_grade(true);
	if (e.getSource() == scrA49i)
	    set_a49_inha(true);
	if (e.getSource() == scrWound)
	    set_wound_wire(true);

	if (e.getSource() == scrBeat4th)
	    set_beat_4th(true);
	if (e.getSource() == scrBeat5th)
	    set_beat_5th(true);
	if (e.getSource() == scrBeatOct)
	    set_beat_octave(true);

	if (e.getSource() == scrBend)
	    set_bend(true);
	if (e.getSource() == scrBendKey)
	    set_bend_key(true);

	if (e.getSource() == scrDamp)
	    set_damp();

	disp_sw();
    }
    public void set_damp() {
	DAMP = 0.01+scrDamp.getValue()/50.0;
	lbDamp.setText("Damping:"+(float)DAMP);

	sw_off();
    }
    public void set_bend(boolean sw) {
	double be = scrBend.getValue()/1000.0;
	lbBend.setText("Bend:"+(float)be);
	if (sw) {
	    MI.setBend(be);
	    is_inha();
	    sw_off();
	}
    }
    public void set_bend_key(boolean sw) {
	int bk = scrBendKey.getValue();
	lbBendKey.setText("BendKey:"+bk);
	if (sw) {
	    MI.setBendKey(bk);
	    is_inha();
	    sw_off();
	}
    }
    public void set_bass_grade(boolean sw) {
	double ib = scrBass.getValue()/1000.0;
	lbBass.setText("BassG:"+(float)ib);

	if (sw) {
	    MI.setBassGrade(ib);
	    is_inha();
	    sw_off();
	}
    }
    public void set_treble_grade(boolean sw) {
	double it = scrTreble.getValue()/1000.0;
	lbTreble.setText("TrebleG:"+(float)it);

	if (sw) {
	    MI.setTrebleGrade(it);
	    is_inha();
	    sw_off();
	}
    }
    public void set_a49_inha(boolean sw) {
	double a49 = scrA49i.getValue()/100.0;
	lbA49i.setText("A49I:"+(float)a49);

	if (sw) {
	    MI.setA49i(a49);
	    is_inha();
	    sw_off();
	}
    }
    public void set_wound_wire(boolean sw) {
	int ww = scrWound.getValue();
	lbWound.setText("WoundW:"+ww);

	if (sw) {
	    TC.setWoundWire(ww);
	    MI.setWoundWire(ww);
	    is_inha();
	    sw_off();
	}
    }
    public void reset_beat_4th() {
	double be = TC.getBeat4th();
	beat_4th_label(be);
	scrBeat4th.setValue(set_beat_value(be));
    }
    public int set_beat_value(double be) {
	return (int)(be*100+300); // -3~3
    }
    public double get_beat_value(int val) {
	return (val-300)/100.0; // -3~3
    }
    public void set_beat_4th(boolean sw) {
	double be = get_beat_value(scrBeat4th.getValue());
	beat_4th_label(be);

	if (sw) {
	    TC.setBeat4th(be);
	    
	    if (AUTO_CENT) {
		reset_beat_5th();
		TC.resetIsCalc();
	    }
	    is_tune();
	    sw_off();
	}
    }
    public void beat_4th_label(double be) {
	lbBeat4th.setText("Beat(P4th):"+dform(be));
    }
    public void reset_beat_5th() {
	double be = TC.getBeat5th();
    	beat_5th_label(be);
	scrBeat5th.setValue(set_beat_value(be));
    }
    public void set_beat_5th(boolean sw) {
	double be = get_beat_value(scrBeat5th.getValue());
	TC.setBeat5th(be);
	beat_5th_label(be);

	if (sw) {
	    if (AUTO_CENT) {
		reset_beat_4th();
		TC.resetIsCalc();
	    }
	    is_tune();
	    sw_off();
	}
    }
    public void beat_5th_label(double be) {
	lbBeat5th.setText("Beat(P5th):"+dform(be));
    }
    public double get_beat_octave() {
	return (scrBeatOct.getValue()-10)/10.0;
    }
    public void set_beat_octave(boolean sw) {
	double be = get_beat_octave();
	set_beatOct_label(be);

	if (sw) {
	    TC.setBeat(be);
	    is_tune();
	    sw_off();
	}
    }
    public void set_beatOct_label(double be) {
	lbBeatOct.setText("Beat(Octave):"+(float)be);
    }
    //
    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == chBass)
	    select_bass_grade();

	if (e.getSource() == chTune)
	    select_tune();

	if (e.getSource() == chOctave)
	    select_octave();

	if (e.getSource() == chInterval)
	    select_interval();

	if (e.getSource() == chPartial)
	    select_partial();

	if (e.getSource() == chSmpl)
	    select_sample();

	disp_sw();
    }
    public void select_sample() {
	N0 = Integer.parseInt(chSmpl.getSelectedItem());

	FFT_SW = false;
	ENVE_SW = false;

	set_nn();
    }
    public void sw_off() {
	WAVE_SW = false;
	FFT_SW = false;
	ENVE_SW = false;
    }
    public void select_partial() {
	sw_off();
    }
    public void select_interval() {
	mouse_check();

	sw_off();
    }
    public void select_octave() {
	TC.setOctaveType(get_octave_type()+OCTAVE);
	TC.resetIsCalc();
	is_tune();
	set_enabled();

	sw_off();
    }
    public int get_octave_type() {
	return chOctave.getSelectedIndex();
    }
    public void set_tune() {
	int t = chTune.getSelectedIndex();
	TC.setTune(t);
    }
    public void select_tune() {
	saveTuneAssort(TA, TC.getTune());
	set_tune();

	TC.resetIsCalc();
	is_tune();

	loadTuneAssort(TA, TC.getTune());
	set_enabled();

	sw_off();
    }
    public void select_bass_grade() {
	MI.setIType(chBass.getSelectedIndex());
	TC.resetIsCalc();

	is_inha();
	sw_off();
    }
    public int[] get_interval_list() {
	return lstInterval.getSelectedIndexes();
    }
    public int get_interval_index() {
	return chInterval.getSelectedIndex();
    }
    public int get_interval_inte() {
	return I.getIvalue(chInterval.getSelectedIndex());
    }
    public String get_interval_name() {
	return I.getIname(chInterval.getSelectedIndex());
    }
    public int get_partial() {
	return Integer.parseInt(chPartial.getSelectedItem());
    }
    public void actionPerformed(ActionEvent e) {
	for (int i = 0; i < Graph.length; i++) {
	    if (e.getSource() == btGraph[i]) {
		set_graph(i);
		break;
	    }
	}
	if (e.getSource() == btDD)
	    GRPH = DEBG;

	else if (e.getSource() == btText)
	    disp_text();

	else if (e.getSource() == btPlus)
	    set_gain(true);
	else if (e.getSource() == btMinus)
	    set_gain(false);

	else if (e.getSource() == btRev)
	    set_reverse();

	else if (e.getSource() == btAbso)
	    set_abso();

	else if (e.getSource() == btAutoB)
	    auto_beat();

	else if (e.getSource() == btAutoCent)
	    auto_cent();

	else if (e.getSource() == btWide)
	    set_wide(true);
	else if (e.getSource() == btNarrow)
	    set_wide(false);

	else if (e.getSource() == btBend)
	    set_bend_btn();

	set_enabled();
	disp_sw();
    }
    public void set_bend_btn() {
	BEND_SW = !BEND_SW;
	btBend.setLabel(BEND_SW ? "BEND" : "Bend");
	MI.IsBend(BEND_SW);
	is_inha();
	sw_off();
    }
    public void set_wide(boolean sw) {
	XBY = sw ? XBY/2 : XBY*2;
	if (XBY < 2)
	    XBY = 2;
    }
    public void set_gain(boolean sw) {
	switch (GRPH) {
        case INHA:
	    break;
	case CENT:
	    CENT_MAX = sw ? CENT_MAX*2 : CENT_MAX/2;
	    if (CENT_MAX < 5)
		CENT_MAX = 5;
	    break;
	case BEAT:
	case PART:
	case ALLL:
	    BEAT_MAX = sw ? BEAT_MAX*2 : BEAT_MAX/2;
	    int min = 1;
	    if (BEAT_MAX < min)
		BEAT_MAX = min;
	    break;
	case WAVE_:
	    WBY = sw ? WBY*2 : WBY/2;
	    break;
	case FFT_:
	    FBY = sw ? FBY*2 : FBY/2;
	    break;
	case ENVE_:
	    EBY = sw ? EBY*2 : EBY/2;
	    break;
	default:
	}
    }
    public void disp_text() {
	GT = !GT;

	btText.setLabel(GT ? "Text " : "Graph");
	Card.next(deck);
    }
    public void set_reverse() {
	REV = !REV;

	btRev.setLabel(REV ? "<-" : "->");
	int tmp = KEY;
	KEY = BKEY;
	BKEY = tmp;
    }
    public void set_abso() {
	ABS = !ABS;

	btAbso.setLabel(ABS ? "ABS" : "abs");
    }
    public void set_graph(int sw) {
	GRPH = sw;

	if (GRPH == BEAT) {
	    BEAT_COUNT++;
	    if (BEAT_COUNT > 1) {
		BEAT_TXT = !BEAT_TXT;
		BEAT_COUNT = 0;
	    }
	} else {
	    BEAT_COUNT = 0;
	}
    }
    public void auto_cent() {
	AUTO_CENT = !AUTO_CENT;

	TC.setAutoCent(AUTO_CENT);
	btAutoCent.setLabel(AUTO_CENT ? "A.C." : "a.c.");

	sw_off();
    }
    public void auto_beat() {
	AUTO_BEAT = !AUTO_BEAT;

	BEAT_TEMP = get_beat_octave(); // temp¸
	reset_auto_beat(BEAT_TEMP);

	sw_off();
    }
    public void reset_auto_beat(double be) {
	btAutoB.setLabel(AUTO_BEAT ? "AUTOBEAT" : "AutoBeat");
	TC.setAutoBeat(AUTO_BEAT);

	reset_beat(be);
	TC.resetIsCalc();
	is_tune();
    }
    public void reset_beat(double be) {
	double val = be*10+10;

	scrBeatOct.setValue((int)val);
	set_beatOct_label(be);
	TC.setBeat(be);
    }
    //
    public void is_inha() {
	if (MI.isCalc()) {
	    MI.resetIsCalc();
	    TC.setInha(MI.getInha());

	    TC.Tuning();
	}
    }
    public void is_tune() {
	if (!TC.isCalc()) {
	    TC.resetIsCalc();

	    TC.Tuning();
	}
    }
    public void re_write() {
	switch (GRPH) {
	case INHA:
	    write_inha();
	    break;
	case CENT:
	    write_cent();
	    break;
	case BEAT:
	    if (ABS)
		write_laying();
	    else
		write_beat();
	    break;
	case PART:
	    write_part();
	    break;
	case ALLL:
	    write_all();
	    break;
	default:
	    write_laying();
	}
    }
    public void write_inha() {
	StringBuffer str = new StringBuffer(1024);
	str.append("Key#: [Hz]: Inharmonicity\n");
	str.append("-------------------------\n");

	for (int i = 0; i < KEY_BOARD; i++) {
	    str.append(getKeyname(i)+": ");
	    str.append(dform(TC.calcFreq(1, i))+": ");
	    str.append(dform(MI.getInha(i)));
	    str.append("\n");
	}
	taA.setText(str.toString());
    }
    public void write_cent() {
	StringBuffer str = new StringBuffer(1024);
	str.append("Key#: [Hz]: [cent]\n");
	str.append("------------------\n");

	for (int i = 0; i < KEY_BOARD; i++) {
	    str.append(getKeyname(i)+": ");
	    str.append(dform(TC.calcFreq(1, i))+": ");
	    str.append(dform(TC.getCent(i)));
	    str.append("\n");
	}
	taA.setText(str.toString());
    }
    public void write_beat() {
	StringBuffer str = new StringBuffer(1024);
	int[] inter = get_interval_list();
	str.append("Key#: [Hz]: ");
	for (int i = 0; i < inter.length; i++) {
	    str.append(" "+I.getIname(inter[i]));
	}
	str.append("\n------------------\n");
	for (int i = 0; i < KEY_BOARD; i++) {
	    str.append(getKeyname(i)+": ");
	    str.append(dform(TC.calcFreq(1, i)));
	    str.append(get_beats(i)+"\n");
	}
	taA.setText(str.toString());
    }
    public void write_part() {
	StringBuffer str = new StringBuffer(1024);
	str.append("Key#: "+getKeyname(KEY));
	str.append(": "+dform(TC.calcFreq(1, KEY))+"[Hz]\n");
	str.append(" Partial: Beat (");
	str.append(get_interval_name()+")\n");
	str.append("-----------------------\n");

	int inte = get_interval_index();
	int key = KEY+ get_interval_inte();
	if (key >= KEY_BOARD)
	    return;

	int max = get_partial();
	for (int i = 1; i <= max; i++) {
	    str.append(i+": ");
	    str.append(dform(TC.getMbeats(KEY, inte, i)));
	    str.append("\n");
	}
	taA.setText(str.toString());
    }
    public void write_all() {
	StringBuffer str = new StringBuffer(1024);
	int multi = get_partial();

	str.append("Key#: [Hz] :");
	for (int j = 1; j <= multi; j++)
	    str.append(" P:"+j);
	str.append("\n-----------------\n");

	int inte = get_interval_index();
	int max = get_interval_inte();
	for (int i = 0; i < KEY_BOARD; i++) {
	    str.append(getKeyname(i)+": ");
	    str.append(dform(TC.calcFreq(1, i)));
	    for (int j = 1; j <= multi; j++) {
		if (REV) {
		    if (i > max) {
			str.append(": ");
			str.append(dform(TC.getMbeats(i, -inte, j)));
		    } else
			str.append(": ...");
		} else {
		    if (i < KEY_BOARD-max) {
			str.append(": ");
			str.append(dform(TC.getMbeats(i, inte, j)));
		    } else
			str.append(": ...");
		}
	    }
	    str.append("\n");
	}
	taA.setText(str.toString());
    }
    public void write_laying() {
	StringBuffer str = new StringBuffer(1024);

	str.append(" #: Key-to-Key: Interval: Beat\n");
        str.append("-------------------------\n");
	int[] keys = TC.getKeys();
	int[] lays = TC.getLays();
	int key0, key1;
	boolean sw;
	for (int i = 0; i < keys.length; i++) {
	    key0 = keys[i];
	    key1 = key0+lays[i];
	    sw = (lays[i] > 0);
	    str.append((i+1)+": ");
	    str.append(getKeyname(sw ? key0 : key1));
	    str.append(sw ? "->" : "<-");
	    str.append(getKeyname(sw ? key1 : key0));
	    str.append(Math.abs(lays[i]) == 5 ? ": P4th" : ": P5th");
	    str.append(": "+dform(TC.calcBeat(key0, key1)));
	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public String get_beats(int key) {
	StringBuffer str = new StringBuffer();
	int[] inter = get_interval_list();
	int max;
	double be;
	for (int i = 0; i < inter.length; i++) {
	    max = I.getIvalue(inter[i]);
	    if (REV) {
		if (key >= max) {
		    str.append(": ");
		    be = TC.calcBeat(key, key-max);
		    be = (ABS) ? Math.abs(be) : be;
		    str.append(dform(be));
		} else
		    str.append(": ...");
	    } else {
		if (key < KEY_BOARD-max) {
		    str.append(": ");
		    be = TC.calcBeat(key, key+max);
		    be = (ABS) ? Math.abs(be) : be;
		    str.append(dform(be));
		} else
		    str.append(": ...");
	    }
	}

	return str.toString();
    }
    public String getKeyname(int num) {
	return (num+1)+"("+getKey(num)+")";
    }
    public String getKey(int key) {
        return (key < 0) ? "" : KEY_NAME[key%OCTAVE];
    }
    //
    public void write_tfdata() {
	StringBuffer sb = new StringBuffer(40);
	sb.append(getKeyname(KEY)+": ");
	sb.append(dform(TC.calcFreq(1, KEY))+"[Hz]");

	switch (GRPH) {
	case INHA:
	    sb.append(": "+dform(MI.getInha(KEY)));
	    break;
	case CENT:
	    sb.append(": "+dform(TC.getCent(KEY)));
	    sb.append("[cent]");
	    break;
	case BEAT:
	    sb.append(get_beats(KEY));
	    break;
	case PART:
	case ALLL:
	    int intn = get_interval_inte();
	    if (REV) {
		if (KEY-intn < 0)
		    break;
	    } else {
		if (KEY+intn >= KEY_BOARD)
		    break;
	    }

	    int max = get_partial();
	    int inte = get_interval_index();
	    double be;
	    for (int i = 1; i <= max; i++) {
		be = (REV) ? TC.getMbeats(KEY, -inte, i) :
		    TC.getMbeats(KEY, inte, i);
		be = (ABS) ? Math.abs(be) : be;
		sb.append(":"+dform(be));
	    }
	    break;
	default:
	}

	tfData.setText(sb.toString());
    }
    public double log_base(double value) {
        return Math.log(value)*BYH;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    //
    public void saveTuneAssort(TuneAssort[] ta, int type) {
	if (ta[type] == null) {
	    ta[type] = new TuneAssort();
	    ta[type].save();

	    if (DEBUG)
		ta[type].debug_write("save(null)");
	} else {
	    ta[type].save();

	    if (DEBUG)
		ta[type].debug_write("save");
	}
    }
    public void loadTuneAssort(TuneAssort[] ta, int type) {
	if (ta[type] == null) {
	    ta[type] = new TuneAssort();
	    ta[type].save();

	    if (DEBUG)
		ta[type].debug_write("load(null)");
	} else {
	    ta[type].load();

	    if (DEBUG)
		ta[type].debug_write("load");
	}
    }
    class TuneAssort {
	private int TUNE;          // NZ,Oct,2oct,Curve,Enve,Tria,clear
	private int OCT_TYPE = -1; // 2:1,4:2,6:3
	private boolean ABsw;      // on,off
	private boolean AUTOB;     // on,off
	private double BEAT;       // 0.0

	public TuneAssort() {}
	public void save() {
	    this.setTuneType(TC.getTune());
	    this.setOctaveType(get_octave_type());
	    this.setAutoBeat(AUTO_BEAT);
	    this.setBeat(get_beat_octave());
	    this.setABsw();
        }
	public void load() {
	    TC.setTune(TUNE);
	    TC.setOctaveType(OCT_TYPE+OCTAVE);

	    if (OCT_TYPE > 0)
		chOctave.select(OCT_TYPE);

	    AUTO_BEAT = this.AUTOB;
	    reset_auto_beat(BEAT);
	}
	public void setTuneType(int t) {
	    if (t > CLEA)
		t = NONZ;
	    TUNE = t;
	}
	public void setOctaveType(int o) {
	    OCT_TYPE = (TUNE == OCT1) ? 0 : -1;
	}
	public void setABsw() {
	    ABsw = (TUNE == OCT1 || TUNE == OCT2) ? true : false;
	}
	public void setAutoBeat(boolean a) {
	    AUTOB = (TUNE == OCT1 || TUNE == OCT2) ? a : false;
	}
	public void setBeat(double b) {
	    BEAT = b;
	}
	public int getTuneType() {
	    return TUNE;
	}
	public int getOctaveType() {
	    return OCT_TYPE;
	}
	public boolean getABsw() {
	    return ABsw;
	}
	public boolean getAutoBeat() {
	    return AUTOB;
	}
	public double getBeat() {
	    return BEAT;
	}
	public void debug_write(String str) {
	    System.out.println(str+": "+toString());
	}
	public String toString() {
	    StringBuffer sb = new StringBuffer();

            sb.append("TuneType:"+TUNE);
	    sb.append(" OctaveType:"+OCT_TYPE);
	    sb.append(" AutoBeatsw:"+ABsw);
	    sb.append(" AutoBeat:"+AUTOB);
	    sb.append(" Beat:"+dform(BEAT));

	    return sb.toString();
	}
    }
    //
    class myCanvas extends Canvas {
        private static final long serialVersionUID = 1L;
        public void update (Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void paintI() {
	bgBlack(gi);

        switch (GRPH) {
        case INHA:
	    disp_aline(gi);
	    disp_inha(gi);
	    break;
	case CENT:
	    disp_aline(gi);
	    disp_cent(gi);
	    break;
	case BEAT:
	    disp_aline(gi);
	    disp_beat(gi);
	    break;
	case PART:
	    disp_partial(gi);
	    break;
	case ALLL:
	    disp_aline(gi);
	    disp_all_partial(gi);
	    break;
	case WAVE_:
	    dispWave(gi);
	    break;
	case FFT_:
	    dispFFT(gi);
	    break;
	case ENVE_:
	    dispEnvelope(gi);
	    break;
	case DEBG:
	    disp_debug(gi);
	    break;
	default:
	}

	write_tfdata();
	disp_octave_label();

	//showStatus("W: "+W+" H: "+H);
    }
    public void bgBlack(Graphics g) {
	g.setColor(Color.black);
        g.fillRect(0, 0, W, H);
    }
    public void setDot() {
        DOT = (int)DKEY;
        while (DOT > DKEY) {
            DOT--;
        }
        if (DOT < 2)
            DOT = 2;

        DSF = DOT/2;
    }
    public void disp_octave_label() {
	if (AUTO_BEAT)
	    lbBeatOct.setText("(AutoBeat):"+dform(TC.getBeat()));
    }
    //
    public void disp_inha(Graphics g) {
	disp_log(g);

	int ww = MI.getWoundWire();
	for (int i = 0; i < KEY_BOARD; i++) {
	    mouse_color(g, i, ww);
	    g.fillOval((int)(i*DKEY),
		       (int)calc_inha(MI.getInha(i)), DOT, DOT);
	}
    }
    public double calc_inha(double val) {
	return H2-Math.log(val)*BYH;
    }
    public void disp_log(Graphics g) {
        double h0 = 0.001, hl;
        int hm;

        for (int i = 1; i < 6; i++) { // ʿ
            hl = h0*Math.pow(10, i);
            hm = (int)calc_inha(hl);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W-1, hm);

            g.setColor(Color.orange); // 
            g.drawString(""+(float)hl, 2, hm);
        }
    }
    public void disp_aline(Graphics g) {
        int wi;

	for (int i = 0; i < KEY_BOARD; i += OCTAVE) {
	    wi = (int)(DKEY*i+DSF);

	    g.setColor(Color.blue);
	    g.drawLine(wi, 0, wi, H);

	    g.setColor(Color.red);
	    g.drawString(OCTAVE_NAME[i/OCTAVE], wi, FONT*2);
        }
    }
    public void mouse_color(Graphics g, int key, int wound) {
        Color co = MC;

        if (key == KEY)
            co = KC;
	else if (key == BKEY)
	    co = Color.gray;
	else if (MC == Color.white && key < wound)
	  co = WC;

        g.setColor(co);
    }
    public void mouse_color(Graphics g, int key, Color mc) {
	Color co = mc;
	if (key == KEY)
	    co = MC;
	else if (key == BKEY)
	    co = Color.gray;

	g.setColor(co);
    }
    //
    public void disp_cent(Graphics g) {
	double dh = (double)H2/CENT_MAX;

	disp_horizontal_line(g, dh);

	double ic;
	int ww = MI.getWoundWire();
	int pmax = get_partial();

	for (int i = 0; i < KEY_BOARD; i++) {
	    mouse_color(g, i, ww);
	    ic = H2-TC.getCent(i)*dh;

	    if (ic < 0 || ic > H)
		continue;
	    g.fillOval((int)(i*DKEY), (int)ic, DOT, DOT);
	}

	disp_diff(g);
    }
    public void disp_diff(Graphics g) {
	g.setColor(Color.red);

	String str = "(diff:"+dform(TC.diffCent())+")";
	int len = fm.stringWidth(str);
	g.drawString(str, (int)(DKEY*33), H-FONT); // f~
    }
    public void disp_horizontal_line(Graphics g, double dh) {
        int hp, hm, xs = 2, hx = CENT_MAX/5;
        double hy, hi;

	disp_center_line(g);

        for (int i = 1; i < 6; i++) {
            hi = hx*i;
            hy = hi*dh;
            hp = (int)(H2+hy);
            hm = (int)(H2-hy);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W, hm);
            g.drawLine(0, hp, W, hp);

            g.setColor(Color.yellow);
            g.drawString(""+hi, xs+2, hm+FONT);
            g.drawString("-"+hi, xs, hp);
        }
    }
    public void disp_center_line(Graphics g) {
        g.setColor(Color.gray);
        g.drawLine(0, H2, W, H2);
    }
    //
    public void disp_beat(Graphics g) {
	disp_beat_line(g);

	int[] inter = get_interval_list();
	int h2 = (ABS) ? H : H2;
	double be, db = h2/(double)BEAT_MAX;
	int max, num, len = inter.length;
	Color mc;
	for (int j = 0; j < len; j++) {
	    num = inter[j]; // number
	    mc = GC[num];
	    if (BEAT_TXT)
		disp_beat_text(g, num, mc, j);

	    max = I.getIvalue(num); // 
	    for (int i = 0; i < KEY_BOARD; i++) {
		mouse_color(g, i, mc);
		if (REV) {
		    if (i < max)
			continue;
		    be = TC.getMbeats(i, -num, 1);
		} else {
		    if (i >= KEY_BOARD-max)
			break;
		    be = TC.getMbeats(i, num, 1);
		}
		disp_value(g, be, db, h2, i);
	    }
	}
    }
    public void disp_beat_text(Graphics g, int n, Color c, int j) {
	String str = I.toString(n);
	int w0 = fm.stringWidth(str);
	g.setColor(c);
	g.drawString(str, W-w0, H-FONT*(j+1));
    }
    public void disp_beat_line(Graphics g) {
	if (!ABS)
	    disp_center_line(g);

	int hp = 0, hm, max = 5, xs = 2;
	int h2 = (ABS) ? H : H2;
	double hi, hv;
	double db = BEAT_MAX/(double)max;
	double dh = h2/(double)max;

        for (int i = 1; i < 6; i++) {
	    hv = i*db;
	    hi = i*dh;
	    hm = (int)(h2-hi);
	    if (!ABS)
		hp = (int)(h2+hi);

            g.setColor(Color.blue);
	    g.drawLine(0, hm, W, hm);
	    if (!ABS)
		g.drawLine(0, hp, W, hp);

            g.setColor(Color.yellow);
            g.drawString(dform(hv), xs+2, hm+FONT);
	    if (!ABS)
		g.drawString("-"+dform(hv), xs, hp);
        }
    }
    //
    public void disp_partial(Graphics g) {
    	int max = get_partial();
	int h2 = (ABS) ? H : H2;
	int dot = (int)(W/(double)PARTIAL/2);
	int dsf = dot/2;
	double be, dp = W/(double)max;
	double db = h2/(double)BEAT_MAX;

	disp_beat_line(g);
	disp_partial_line(g, dp, max, dsf);

	int key = REV ? KEY-get_interval_inte() :
	    KEY+get_interval_inte();
	if (REV) {
	    if (key < 0)
		return;
	} else {
	    if (key >= KEY_BOARD)
		return;
	}

	int ii, inte = get_interval_index();
	double gin, val;
	for (int i = 0; i < max; i++) {
	    ii = i+1;
	    be = (REV) ? TC.getMbeats(KEY, -inte, ii) :
		TC.getMbeats(KEY, inte, ii);
	    be = (ABS) ? Math.abs(be) : be;
	    val = h2-be*db-dsf;
	    if (val < 0 || val > H)
		continue;

	    gin = TC.calcSindo(TC.calcFreq(ii, KEY), ii, KEY);
	    g.setColor(calcColor(gin));

	    g.fillOval((int)(i*dp), (int)val, dot, dot);
	}
    }
    public Color calcColor(double val) {
	Color col = Color.orange;
	float sft = 0.3f;
        float[] c0 = new float[3];
	Color.RGBtoHSB(col.getRed(), col.getGreen(), col.getBlue(), c0);

        c0[2] = (float)(c0[2]*val+sft); //  0~1
        if (c0[2] > 1.0f)
            c0[2] = 1.0f;
        col = Color.getHSBColor(c0[0], c0[1], c0[2]);

        return col;
    }
    public void disp_partial_line(Graphics g,
				  double dx, int max, int dsf) {
	int wd;
	for (int i = 0; i < max; i++) {
	    wd = (int)(i*dx+dsf);

	    g.setColor(Color.blue);
	    g.drawLine(wd, 0, wd, H);

	    g.setColor(Color.orange);
	    g.drawString(""+(i+1), wd, FONT*2);
	}
    }
    //
    public void disp_all_partial(Graphics g) {
	disp_beat_line(g);

	int multi = get_partial();
	int inte = get_interval_index();
	int max = get_interval_inte();   // 
	int h2 = (ABS) ? H : H2;
	int jj;
	double be, db = h2/(double)BEAT_MAX;
	Color mc;
	int itv[] = I.getIdata(inte);

	for (int j = 0; j < multi; j++) { // ܲ
	    mc = GC[j];
	    jj = j+1;
	    disp_inter_string(g, mc, jj, itv);

	    for (int i = 0; i < KEY_BOARD; i++) { // end
		mouse_color(g, i, mc);
		if (REV) {
		    if (i < max)
			continue;
		    be = TC.getMbeats(i, -inte, jj);
		} else {
		    if (i >= KEY_BOARD-max)
			break;
		    be = TC.getMbeats(i, inte, jj);
		}
		disp_value(g, be, db, h2, i);
	    }
	}
    }
    public void disp_inter_string(Graphics g, Color c, int jj, int[] itv) {
	String str = itv[0]*jj+":"+itv[1]*jj;
	int len = fm.stringWidth(str);

	g.setColor(c);
	g.drawString(str, W-len, FONT*(3+jj));
    }
    public void disp_value(Graphics g, double be, double db,
			   int h2, int i) {
	be = (ABS) ? Math.abs(be) : be;
	int val = (int)(h2-be*db-DSF);
	if (val < 0 || val > H)       // ɻ
	    return;

	g.fillOval((int)(i*DKEY), val, DOT, DOT);
    }
    //
    public void dispWave(Graphics g) {
	disp_center_line(g);

	if (!WAVE_SW)
	    makeWave();

	int x, y;
	double dx = W/(double)WAVE_LEN;
	g.setColor(Color.green);
	for (int i = 0; i < WAVE_LEN; i++) {
	    x = (int)(dx*i);
	    y = (int)(H2-Wave[i]*WBY);

	    g.drawLine(x, y, x, y);
	}
	
	disp_wave_time(g);
    }
    public void disp_wave_time(Graphics g) {
	double allsec = WAVE_LEN/(double)SPLGF;
	double tim = get_tim(allsec);
	int asec = (int)(tim/(allsec/W));
	int maxsec = (int)(allsec/tim);

	if (maxsec > 0) {
	    int x;

	    for (int i = 0; i <= maxsec; i++) {
		x = asec*i;
		g.setColor(Color.gray);
		g.drawLine(x, BASE, x, BASE+FONT);

		g.setColor(Color.orange);
		g.drawString(dform(i*tim), x, H);
	    }
	}

	String sc = "[sec]";
	int len = fm.stringWidth(sc);
	g.setColor(Color.yellow);
	g.drawString(sc, W-len, BASE+FONT);

	disp_base_line(g);
    }
    public double get_tim(double allsec) {
	double tim;

	if (allsec < 0.1)
	    tim = 0.01;
	else if (allsec < 0.3)
	    tim = 0.05;
	else if (allsec < 1)
	    tim = 0.1;
	else if (allsec < 3)
	    tim = 0.5;
	else if (allsec < 10)
	    tim = 1;
	else if (allsec < 30)
	    tim = 5;
	else if (allsec < 60)
	    tim = 10;
	else
	    tim = 60;

	return tim;
    }
    public void makeWave() {
	Wave = new double[WAVE_LEN];
	
	make_wave(KEY);
	if (BKEY != KEY)
	    make_wave(BKEY);

	WAVE_SW = true;
    }
    public void make_wave(int key) {
	int pmax = get_partial();
	double[] partf = new double[pmax];
	double[] gain = new double[pmax];
	double fp, t;
	int pa;

	for (int j = 0; j < pmax; j++) {
	    pa = j+1;
	    partf[j] = TC.calcFreq(pa, key);
	    gain[j] = TC.calcSindo(partf[j], pa, key);
	}
	for (int j = 0; j < pmax; j++) {
	    fp = partf[j]*P2;
	    t = 0;
	    for (int i = 0; i < WAVE_LEN; i++) {
		Wave[i] += Math.sin(fp*t)*gain[j]*Math.exp(-t*DAMP);
		t += TD;
	    }
	}
    }
    public void init_samplingf() {
	WAVE_LEN = (int)(TIME*SPLGF);
	TD = 1.0/SPLGF;
	Enve = new double[WAVE_LEN];
    }
    public void init_wave() {
	Wave = new double[WAVE_LEN];
    }
    //
    public void dispFFT(Graphics g) {
        int x = 0, y = 0;
        int w = N/XBY;
        double dw = W/(double)w;

	disp_rule(g);
        disp_fft_line(g);

	if (!WAVE_SW)
	    makeWave();
	if (!FFT_SW)
	    calc_fft();
 
        g.setColor(Color.green);
        for (int i = 0; i < w; i++) {
            x = (int)(dw*i);
            y = (int)(Dat[i]*FBY);

            g.drawRect(x, BASE-y, (int)dw, y);
        }
    }
    public void disp_rule(Graphics g) {
	int mej, dx, max = SPLGF/XBY;
	double wdf = W/(double)max;

	for (int i = 0; i <= max; i += 10) {
 	    if (i % 10000 == 0) {
		mej = 20;
		if (max >= 10000)
		    disp_unit(g, i, wdf);
	    } else if (i % 5000 == 0) {
		mej = 17;
		if (max >= 5000)
		    disp_unit(g, i, wdf);
	    } else if (i % 1000 == 0) {
		mej = 14;
		if (max < 12000)
		    disp_unit(g, i, wdf);
	    } else if (i % 500 == 0) {
		if (max > 23000)
		    continue;
		mej = 11;
	    } else if (i % 100 == 0) {
		if (max > 12000)
		    continue;
		mej = 9;
	    } else if (i % 50 == 0) {
		if (max > 4000)
		    continue;
		mej = 6;
	    } else if (i % 10 == 0) {
		if (max > 2000)
		    continue;
		mej = 3;
	    } else
		continue;

	    dx = (int)(i*wdf);
	    g.setColor(Color.gray);
            g.drawLine(dx, BASE, dx, BASE+mej);
	}
    }
    public void disp_unit(Graphics g, int k, double wdf) {
	g.setColor(Color.orange);
	g.drawString(k/1000+"k", (int)(k*wdf), H-FONT);
    }
    public void disp_base_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, BASE, W, BASE);
    }
    public void disp_fft_line(Graphics g) {
        int lmax = 10, y;
        double h = BASE/(double)lmax;

	g.setColor(Color.darkGray);
        for(int i = 1; i < lmax; i++) {
            y = (int)(h*i);
            g.drawLine(0, y, W, y);
	}
    }
    public void calc_fft() {
	gauss();
	fft();

	FFT_SW = true;
    }
    public void init_gauss() {
	Gauss = new double[N];
	double is, lps = 1.0/N;

	for (int i = 0; i < N; i++) {
	    is = (2.0*i-N)*lps;
	    Gauss[i] = Math.exp(-4.5*is*is);
	}
    }
    public void gauss() {
	for (int i = 0; i < N; i++)
	    Im[i] = Re[i] = (i >= WAVE_LEN) ? 0 : Gauss[i]*Wave[i];
    }
    public void fft() {
        F.fft(Re, Im);
        for (int i = 0; i < N/2; i++)
            Dat[i] = Math.sqrt(Re[i]*Re[i]+Im[i]*Im[i]);
    }
    //
    public void dispEnvelope(Graphics g) {
	disp_base_line(g);
        disp_fft_line(g);

	if (!WAVE_SW)
	    makeWave();
	if (!ENVE_SW)
	    calcEnvelope();

        int x, y;
	double dx = W/(double)WAVE_LEN;

        g.setColor(Color.cyan);
        for (int i = 0; i < WAVE_LEN; i++) {
            x = (int)(dx*i);
            y = (int)(BASE-Enve[i]*EBY);

            g.drawLine(x, y, x, y);
        }

	disp_wave_time(g);
    }
    public void calcEnvelope() {
	double[] re = new double[N];
        double[] im = new double[N];
        int n = 0;
        int ii = 0;
	int devid = (int)(WAVE_LEN/(double)N+1);

        for (int j = 0; j < devid; j++) {
            n = j*N;
            ii = 0;
            for (int k = 0; k < N; k++) {
                ii = k+n;
                re[k] = im[k] = (ii >= WAVE_LEN) ? 0.0 :
                    Math.pow(Wave[ii], 2);
            }

            F.fft(re, im);
            for (int l = 0; l < N; l++) {
                if (FF[l] > 10 && FF[l] < (SPLGF - 10)) // 10[Hz]
                    re[l] = im[l] = 0.0;
            }

            F.ifft(re, im);
	    ii = 0;
            for (int i = 0; i < N; i++) {
                ii = i+n;
                if (ii >= WAVE_LEN)
                    break;
                else
                    Enve[ii] = re[i];
            }
        }

        ENVE_SW = true;
    }
    public void init_envelope() {
	double sn = SPLGF/(double)N;
	FF = new double[N];
        for (int i = 0; i < N; i++)
            FF[i] = sn*i;
    }
    //
    public void disp_debug(Graphics g) {
	DebugData dd = TC.getDD(KEY);
	if (dd == null) {
	    disp_dlaying(g);
	    return;
	}

	disp_dline(g, dd);

	int len = dd.getLength();
	double bx = dd.getBeatMax()-dd.getBeatMin(); //
	double dx = W/(double)len;
	double dy = H2/bx; // H/bx
	int dot = (int)(dx-2);
	int dots = dot/2;
	if (dot < 2) {
	    dot = 2;
	    dots = 1;
	}

	//System.out.println("len: "+len);
	//System.out.println("beat max:"+bx);

	int xx, yy;
	double val;
	g.setColor(Color.green);
	for (int i = 0; i < len; i++) {
	    xx = (int)(dx*i-dots);
	    val = dd.getData(i);
	    if (val == 0)
		continue;
	    yy = (int)(H2-val*dy-dots); // (int)(H-val*dy-dots);
	    g.fillOval(xx, yy, dot, dot);
	}

	disp_ddata(g, dd);
    }
    public void disp_dlaying(Graphics g) {
	g.setColor(Color.green);
	g.drawString("*** not use. ***", W/3, H2);
    }
    public void disp_dline(Graphics g, DebugData dd) {
	int xx, len = dd.getLength();
	int wid = len/100;
	double dw = W/(double)wid;
	double dc = (dd.getCentEnd()-dd.getCentStart())/wid;

	g.setColor(Color.gray);
	for (int i = 0; i < wid; i++) {
	    xx = (int)(dw*i);

	    g.setColor(Color.gray);
	    g.drawLine(xx, 0, xx, H);

	    g.setColor(Color.red);
	    g.drawString(""+dform(i*dc+dd.getCentStart()), xx, H);
	}
    }
    public void disp_ddata(Graphics g, DebugData dd) {
	g.setColor(Color.orange);
	g.drawString("Max: "+dform(dd.getBeatMax()), 10, FONT);
	g.drawString("Min :"+dform(dd.getBeatMin()), 10, FONT*2);
	g.drawString("Cent: "+dform(dd.getCentStart())+
		     "("+dform(dd.getCentEnd())+")", W/2, FONT);
    }
}
